// Created by:

// Coding 		Eric Lussier		www.threetree.com		Barcelona, Spain
// Styling		Pat Heard			www.fullahead.org		Ottawa, Canada

// Please send comments, questions & enhancement requests 
// to gpeeker@gmail.com

// Released under the RIP, MIX & BURN License Spring 2005...   Do with it as you may

// Although if you try to profit from this... you suck big ass!
// You MAY NOT take this code and put a new face on it

// DISCLAMER:	This piece of software is provided as is and is used at your own risk.
//				We are not responsible for any damage or lost data due to the use of this program.

// Many thanks to:

// Apple		www.apple.com		Their Stretcher example code was a great place to start and has been robustly upgraded... if only everyone knew the joy of all things apple!
// Google		www.google.com		I would love to see some improvements in their API but the atom feed is a good start... keep doing no evil!
// Findory		www.findory.com		He has a great XML feed widget which provided a nice framework to start from... go check it out!

// For those that enjoy poking around you can use this functions results will appear at the top of the widget
// debug("gpeek");


// Le Globals

var stretcher;
var horizontal_stretcher;
var stretcher_summary;

var feedReq = null;

var username = "";
var pass = "";
var mail_count = 0;
var prev_mail_count = 0;

// timers
var reqTimer;
var sumTimer;
var relTimer;

var isVWidgetOpen = false;
var isHWidgetOpen = true;
var isSummaryOpen = false;
var enableSummary = false;

var isFlip = false;
var prefChange = false;

var feed_timeout = 30000; 		// 30 Seconds
var feed_reload = 10; 			// 10 Minutes

var pref_auto_open = true;
var pref_auto_check = false;
var pref_always_check = true;
var pref_pod = true;

var isFirstTime = false;

var last_pod = "20050101";
var showPOD = false;
var thumb = new Image();

var thisVersion = "v1.0";
var newVersion = false;

// Constants - do not change

var HORIZONTAL = false;
var VERTICAL = true;
var RESIZE_WIDGET = true;
var NO_RESIZE_WIDGET = false;


function init() {

	// Create instances for the three main slidding components
	stretcher = new Stretcher(document.getElementById('front'), 700, widgetVResize, VERTICAL);
	horizontal_stretcher = new Stretcher(document.getElementById('front'), 700, widgetHResize, HORIZONTAL);
	stretcher_summary = new Stretcher(document.getElementById('summary'), 400, summaryResize, VERTICAL);
	
    createGenericButton(document.getElementById("done"), "Done", hidePrefs);
    
    if (window.widget) {
		widget.onshow = onShow;
		widget.onhide = onHide;
		widget.onremove = onRemove;
		
		getPersistantPrefs();
    }
       
    checkVersion();   
       
    setBackPrefs();
    
   	reloadFeed();

}

function onShow() {
	if (username != "" && pref_always_check) {
	    reloadFeed();
	}
}

function onHide() {
	if (isFirstTime)
		setTimeout("widget.openURL('http://www.threetree.net/widgets/gpeek/')",1000);
		
	isFirstTime = false;
}

// Called when the widget is Xed out. We don't want to leave any traces

function onRemove() {

	widget.setPreferenceForKey(null, createkey("username"));
	widget.setPreferenceForKey(null, createkey("pass"));
	widget.setPreferenceForKey(null, createkey("feed_reload"));
	widget.setPreferenceForKey(null, createkey("pref_auto_open"));
	widget.setPreferenceForKey(null, createkey("pref_auto_check"));
	widget.setPreferenceForKey(null, createkey("pref_always_check"));
	widget.setPreferenceForKey(null, createkey("pref_pod"));
	widget.setPreferenceForKey(null, createkey("last_pod"));
	
	clearInterval(reqTimer);
	reqTimer = null;
	
	clearInterval(relTimer);
	relTimer = null;
	
	req = null;
}

// Creates an instance-specific version of a key for persistent Dashboard state storage.

function createkey(key) {
	return widget.identifier + "-" + key;
}

// Drops all the prefs into a file everytime the widget is flipped back

function setPersistantPrefs() {

	widget.setPreferenceForKey(document.theform.username.value, createkey("username"));
	widget.setPreferenceForKey(encrypt(document.theform.pass.value), createkey("pass"));
	widget.setPreferenceForKey(document.theform.feed_reload.value, createkey("feed_reload"));
	
	widget.setPreferenceForKey(document.theform.pref_auto_open.checked, createkey("pref_auto_open"));
	widget.setPreferenceForKey(document.theform.pref_auto_check.checked, createkey("pref_auto_check"));
	widget.setPreferenceForKey(document.theform.pref_always_check.checked, createkey("pref_always_check"));
	widget.setPreferenceForKey(document.theform.pref_pod.checked, createkey("pref_pod"));
		
	return true;
}

// Grabs all the info from the preference file when dashboard reloads

function getPersistantPrefs() {

	if (widget.preferenceForKey(createkey("username")) != null) {

	    username = widget.preferenceForKey(createkey("username"));
    	pass = decrypt(widget.preferenceForKey(createkey("pass")));
	    feed_reload = widget.preferenceForKey(createkey("feed_reload"));
	   	    
		pref_auto_open = widget.preferenceForKey(createkey("pref_auto_open"));
		pref_auto_check = widget.preferenceForKey(createkey("pref_auto_check"));
		pref_always_check = widget.preferenceForKey(createkey("pref_always_check"));
		pref_pod = widget.preferenceForKey(createkey("pref_pod"));
		last_pod = widget.preferenceForKey(createkey("last_pod"))!= null?widget.preferenceForKey(createkey("last_pod")):last_pod;
	}
	
	return true;
}

// Sets all the fields on the back with the globals

function setBackPrefs () {

	document.theform.username.value = username;
	document.theform.pass.value = pass;
	document.theform.feed_reload.value = feed_reload;

	document.theform.pref_auto_open.checked = pref_auto_open;
	document.theform.pref_auto_check.checked = pref_auto_check;
	document.theform.pref_always_check.checked = pref_always_check;
	document.theform.pref_pod.checked = pref_pod;

	return true;
}

// Gets all the prefs that have been set on the back and puts them into globals

function getBackPrefs() {

	username = document.theform.username.value;
	pass = document.theform.pass.value;
	feed_reload = document.theform.feed_reload.value;

	pref_auto_open = document.theform.pref_auto_open.checked;
	pref_auto_check = document.theform.pref_auto_check.checked;
	pref_always_check = document.theform.pref_always_check.checked;
	pref_pod = document.theform.pref_pod.checked;
	
	return true;
}

// Reloads the feed - All preferences should be set if not redirect to the prefs

function reloadFeed() {

    if (username && pass) {
    
        checkPOD();
    
    	document.getElementById('connected').innerHTML = "Loading...";
		
    } else {
    
    	document.getElementById('connected').innerHTML = "Specify gmail account...";
    	
    	setTimeout('showPrefs(event)',2000);
    	
    	return false;
    }

	prev_mail_count = document.getElementById('small_count').innerHTML;

	// if the widget is in mini mode we need some indicator that it's reloading
	if (!isHWidgetOpen) {
		document.getElementById('small_count').innerHTML = "~";
	}

	if (feedReq != null) {
		feedReq.abort();
		feedReq = null;
	}
		
	feedReq = new XMLHttpRequest();
	feedReq.open("GET", "https://" + username + ":" + pass + "@mail.google.com/mail/feed/atom", true);
	feedReq.setRequestHeader("Cache-Control", "no-cache");
		
	feedReq.onload = processReq;
   	feedReq.send(null);

    reqTimer = setTimeout('feedError()',feed_timeout);
}

function processReq() {

	if (feedReq.responseXML != null) {

		clearInterval(reqTimer);
		reqTimer = null;
			
		if (username.length > 14) {
			document.getElementById('connected').innerHTML = username;
		} else {
			document.getElementById('connected').innerHTML = "peeking " + username;
		}

		var items = feedReq.responseXML.getElementsByTagName("entry");
		
		var htmlDisplay = "";
	
		for (var i = 0; i < items.length; i++) {
	
			// Grab the info from the atom feed
			var title = items[i].firstChild.firstChild!=null?items[i].firstChild.firstChild.nodeValue:"";
		    var summary = getElementTextNS("summary", items[i], 0);
		    //var link = getElementTextNS("link", items[i], 0);  // this is not very useful at this time
	    	var issued = getElementTextNS("issued", items[i], 0);
	    	var id = getElementTextNS("id", items[i], 0);
			var email = items[i].getElementsByTagName("author")[0].getElementsByTagName("email")[0].firstChild.nodeValue;
			var name = items[i].getElementsByTagName("author")[0].getElementsByTagName("name")[0].firstChild.nodeValue;

			if (title == "")
				title = "no subjet";

	    	// Trim the title to fit the UI
	    	if (title.length > 25) {
				title = title.substr(0, 25);
				title += '...';
		    }
		    
		    // Trim the email address to fit the UI
	    	if (email.length > 27) {
				email = email.substr(0, 27);
				email += '...';
		    }		    
		    
			// Format all the info so that it looks all purdey
			htmlDisplay += ("<div id='thin_message" + i + "' class='thin_message' onMouseOver='messageMouseOver(event," + i + ")' onMouseOut='messageMouseOut(event," + i + ")' onClick='openGmail()'><div id='message" + i + "' class='message'>" +
					"<div id='arrow" + i + "' class='arrow'></div>" +
					"<div id='subject" + i + "' class='subject'>" + title + "</div>" +
					"<div id='sender" + i + "' class='sender'>" + email + "</div>" +
					"<div id='date" + i + "' class='date'>" + formatDate(issued) + "</div>" +
					"<div id='sum" + i + "' class='sum'>" + summary + "</div>" +
					"</div></div>");			
		}

		mail_count = feedReq.responseXML.getElementsByTagName("fullcount")[0].firstChild.nodeValue;


		if (isFirstTime	) {
			
			htmlDisplay += ("<div id='thin_message97' class='thin_message' onMouseOver='messageMouseOver(event,97)' onMouseOut='messageMouseOut(event,97)'><div id='message97' class='message'>" +
					"<div id='arrow97' class='arrow'></div>" +
					"<div id='subject97' class='subject'>Welcome to GPeek</div>" +
					"<div id='sender97' class='sender'>When you just want a quick peek</div>" +
					"<div id='date97' class='date'>Gmail + Dashboard</div>" +
					"<div id='sum97' class='sum'>Thanks for downloading GPeek. Be sure to check out the help section on our site to get the most out of GPeek. Enjoy!!</div>" +
					"</div></div>");
					
			mail_count++;
		}
								
		
		if (newVersion) {
		
			htmlDisplay += ("<div id='thin_message98' class='thin_message' onMouseOver='messageMouseOver(event,98)' onMouseOut='messageMouseOut(event,98)'><div id='message98' class='message'>" +
					"<div id='arrow98' class='arrow' onClick='openVersion()'></div>" +
					"<div id='subject98' class='subject' onClick='openVersion()'>New Version of GPeek</div>" +
					"<div id='sender98' class='sender' onClick='openVersion()'>Grab the latest at <font color='#FFC000'>ThreeTree</font></div>" +
					"<div id='date98' class='date'>New features in " + latest_version + "</div>" +
					"<div id='sum98' class='sum'>" + latest_features + "</div>" +
					"<div id='dismiss98' class='dismiss' onClick='newVersion = false; reloadFeed();'>X</div>" +
					"</div></div>");
					
			mail_count++;	
		}


		if (showPOD && pref_pod) {
								
			htmlDisplay += ("<div id='thin_message99' class='thin_message' onMouseOver='messageMouseOver(event,99)' onMouseOut='messageMouseOut(event,99)'><div id='message99' class='message'>" +
					"<div id='arrow99' class='arrow' onClick='openPOD(\"" + last_pod + "\")'></div>" +
					"<div id='subject99' class='subject' onClick='openPOD(\"" + last_pod + "\")'>Picture of the Day</div>" +
					"<div id='sender99' class='sender' onClick='openPOD(\"" + last_pod + "\")'>courtesy of <font color='#FFC000'>ThreeTree</font></div>" +
					"<div id='date99' class='date'></div>" +
					"<div id='sum99' class='sum'><img src='" + thumb.src + "' name='pod_thumb' onClick='openPOD(\"" + last_pod + "\")'></div>" +
					"<div id='dismiss99' class='dismiss' onClick='PODViewed(new Date()); showPOD = false; reloadFeed();'>X</div>" +
					"</div></div>");
					
			mail_count++;
		}	


		// It should only go to full view if there is new mail so that it doesnt open everytime the user goes to dashboard
		var newMail = false;
		
		if (mail_count > prev_mail_count) {
			newMail = true;
		}

		document.getElementById('big_count').innerHTML = mail_count;
		document.getElementById('small_count').innerHTML = mail_count;
		
		if ( mail_count == 0 ) {
			htmlDisplay = "<div id='no_mail'>No new mail...</div>";
			newMail = false;
		}

		document.getElementById('mail').innerHTML = htmlDisplay;
		
		if (pref_auto_open && !isVWidgetOpen && newMail) {
			toggleVOpen();
		} else if (isVWidgetOpen) {
			stretcher.stretch(event, 39 * mail_count + 180, RESIZE_WIDGET, VERTICAL);
		} else {
		}
		
		clearInterval(relTimer);
		relTimer = null;
	
		if (pref_auto_check)
			relTimer = setTimeout('reloadFeed()',feed_reload * 60000);
		
	} else {
		feedError();
	}

}


// Called after the feed_timeout expires indicating that there was an error loading the feed
// Could be a bad URL or an invalid username/pass

function feedError() {

	if (!isHWidgetOpen) {
		toggleHOpen();
		setTimeout('feedError()',700);
		return false;
	}
	
	document.getElementById('big_count').innerHTML = "!&nbsp;";
	document.getElementById('small_count').innerHTML = "!&nbsp;";

	document.getElementById('connected').innerHTML = "Error loading feed";
	
	htmlDisplay = 	("<div id='errorMsg'>Problems...try...<br><br>" +
					"<li>Reloading the widget by pressing<br>&nbsp;&nbsp;&nbsp;command-R</li>" + 
					"<li>Re-entering your username &<br>&nbsp;&nbsp;&nbsp;password in the preferences</li>" + 
					"<li>Accessing the Gmail atom feed in<br>&nbsp;&nbsp;&nbsp;your browser by clicking <font color='#45923F'><a href'#' onClick='if (window.widget) widget.openURL(\"https://" + username + ":" + pass + "@mail.google.com/mail/feed/atom\");'>here</a></font></li>" +
					"<li>Accessing your Gmail inbox by<br>&nbsp;&nbsp;&nbsp;clicking the envelope logo above</li>" +
					"</div>");
	
	document.getElementById('mail').innerHTML = htmlDisplay;
	
	stretcher.stretch(event, 280, RESIZE_WIDGET, VERTICAL);
	
	clearInterval(reqTimer);
	reqTimer = null;
	
	clearInterval(relTimer);
	relTimer = null;

}

// Encrypts the password so that it can be stored in the plain text prefs file

function encrypt(thisPass) {

	var key = "abcdefghijklmnopqrstuvwxyz1234567890";
	var index = 0;
	var tmp = "";
	
	for (i = 0; i < thisPass.length; i++) {

		index = key.indexOf(thisPass.charAt(i)) + 5;

		if (index == 4) {
			tmp += thisPass.charAt(i);
		} else if (index > 36) {
			index = index - 36;
			tmp += key.charAt(index);
		} else {
			tmp += key.charAt(index);
		}
	}

	return tmp;
}

// Decrypts what going on above

function decrypt(thisPass) {

	var key = "abcdefghijklmnopqrstuvwxyz1234567890";
	var index = 0;
	var tmp = "";
	
	for (i = 0; i < thisPass.length; i++) {

		index = key.indexOf(thisPass.charAt(i)) - 5;

		if (index == -6) {
			tmp += thisPass.charAt(i);
		} else if (index < 0) {
			index = index + 36;
			tmp += key.charAt(index);
		} else {
			tmp += key.charAt(index);
		}
	}
	
	return tmp;
}	

// Checks for the latest version

function checkVersion () {

	if (latest_version == thisVersion) {
		document.getElementById('version').innerHTML = "<font color='#FFC000'>" + thisVersion + "</font>";
	} else {
		newVersion = true;
		document.getElementById('version').innerHTML = "<font color='#FFC000'>New Version Available!</font>";	
	}
}

// Retrieves a specific element from the XML feed
// Parameters:	local 		- id of the element to be retrieved
//				parentElem	- the actual parent element
//				index		- the occurance wanted to retrieve - usually the first which is 0

function getElementTextNS (local, parentElem, index) {

    var result = "";

    result = parentElem.getElementsByTagName(local)[index];

    if (result && result.firstChild != null) {

        if (result.childNodes.length > 1) {
        	return result.childNodes[1].nodeValue;
        } else {
            return result.firstChild.nodeValue;    
        }
        
    } else {
    	return "No summary...";
    }
}

// Used to format the date that appears in the summary slidder
// Parameter: thisDate - Google formated date/time stamp directly from the atom feed

function formatDate(thisDate) {

	var months = new Array("Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec");
	
	var thisMonth = thisDate.substr(5,2);
	var thisDay = thisDate.substr(8,2);
	
	var thisTime = thisDate.substr(11,5);
	
	if (thisTime.substr(0,2) > 12) {
		thisTime = thisTime.substr(0,2)-12 + thisTime.substr(2) + "PM";
	} else {
		thisTime = thisTime + "AM";
	}

	thisMonth = ( thisMonth.substr(0,1) == "0" ? months[thisMonth.substr(1,1)-1] : months[thisMonth]-1 );
	
	return thisMonth + "&nbsp;" + thisDay + "&nbsp;@&nbsp;" + thisTime;

}

// Format the PoD date given a jaavscript date

function formatPoDDate(thisDate) {


	var formated  = thisDate.getFullYear().toString();
	
	if (thisDate.getMonth() < 8) formated += "0";
		
	formated += (thisDate.getMonth() + 1).toString();
	
	if (thisDate.getDate() < 10) formated += "0";
			
	formated += thisDate.getDate().toString();

	return formated;

}

// Checks for the latest picture of the day on threetree.net

function checkPOD() {

	var today = new Date();
		
	var last = new Date();
	
		last.setFullYear(last_pod.substring(0,4));
		last.setMonth(parseInt(last_pod.substring(4,6))-1);
		last.setDate(last_pod.substring(6,8));
		get_version();

	if (today > last) {
		
		showPOD = true;
		
		last_pod = formatPoDDate(today);
				
		thumb.src = "http://www.threetree.net/pod/gpeek_thumbs/" + last_pod + ".jpg";	
	
	}
}

// Set's it so that the POD only displays once a day

function PODViewed(today) {

	last_pod = formatPoDDate(today);
	
	widget.setPreferenceForKey(last_pod, createkey("last_pod"));
	
}

// Called when the widget is finished VERTICALLY resizing

function widgetVResize () {

	if (!isFlip) {
	
		if (document.getElementById('front').style.height == "69px") {
	
			document.getElementById('vertical_control').style.backgroundImage = 'url("Images/Arrow-V-Open.gif")';
			isVWidgetOpen = false;
		
		} else {
	
			document.getElementById('vertical_control').style.backgroundImage = 'url("Images/Arrow-V-Close.gif")';
			isVWidgetOpen = true;
		}
		
		enableSummary = true;
	}
}

// Called when the widget is finished HORIZONTALLY resizing

function widgetHResize () {

	if (isHWidgetOpen) {
	
		document.getElementById('horizontal_control').style.backgroundImage = 'url("Images/Arrow-H-Open.gif")';
		isHWidgetOpen = false;
		
	} else {
		
		fadeLogo();
		
		document.getElementById('horizontal_control').style.backgroundImage = 'url("Images/Arrow-H-Close.gif")';
	
		isHWidgetOpen = true;
	}
}

// Called when the SUMMARY is finished resizing

function summaryResize () {

	if (isSummaryOpen) {
		isSummaryOpen = false;
	} else {
		isSummaryOpen = true;
	}
}

// Called when the widget comes back from the flip side

function restoreSize () {

	if (isVWidgetOpen && !prefChange) {
			
		isFlip = true;	
		stretcher.stretch(event, 39 * mail_count + 180, RESIZE_WIDGET, VERTICAL);
		
	} else {
		
		stretcher.stretch(event, 69, RESIZE_WIDGET, VERTICAL);
	
	}
	
	setTimeout('isFlip=false',800);

}


// Called to flip the widget to show the preferences. 
// Also resize the widget to the same size as the back grfx for aesthetic reasons

function showPrefs() {

	if ((isVWidgetOpen || isHWidgetOpen) && !isFlip) {
			
		isFlip = true;	
		stretcher.stretch(event, 155, RESIZE_WIDGET, VERTICAL);
		setTimeout('showPrefs()',800);
		return false;
		
	} else if (!isHWidgetOpen) {
	
		toggleHOpen();
		setTimeout('showPrefs()',800);
		return false;
	}
	
	prefChange = false;

    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget)
        widget.prepareForTransition("ToBack");

    front.style.display="none";
    back.style.display="block";

    if (window.widget)
        setTimeout ('widget.performTransition();', 0);

	clearInterval(relTimer);
	relTimer = null;
        
    if (document.theform.username.value == "") {
    	document.theform.username.focus();
    	isFirstTime = true;
    }
}

// Called to flip the widget back to the front side and restore the position
// unless the prefs have been changed in which case it goes to long mode

function hidePrefs() {

	if (document.theform.username.value.indexOf("@")!=-1)
		document.theform.username.value = document.theform.username.value.substring(0,document.theform.username.value.indexOf("@"));

	setPersistantPrefs();
	
	getBackPrefs();

    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget)
        widget.prepareForTransition("ToFront");

    back.style.display="none";
    front.style.display="block";
    
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);  
        
   	if (prefChange) {
		reloadFeed();
	}	
	
	clearInterval(relTimer);
	relTimer = null;
	
	if (pref_auto_check)
		relTimer = setTimeout('reloadFeed()',feed_reload * 60000);	
	
	
	setTimeout('restoreSize()',800);
}


// Opens gmail in the default browser and logs-in automatically

function openGmail() {

	if (isVWidgetOpen) {
		
		setTimeout('stretcher.stretch(event, 69, RESIZE_WIDGET, VERTICAL)',800);
		
	}

	if (username!="") {
		if (window.widget)
			widget.openURL('https://www.google.com/accounts/ServiceLoginAuth?service=mail&Email=' + username + '&Passwd=' + pass + '&continue=https://gmail.google.com/gmail');
	} else {
		showPrefs();
	}
}

// Opens juicy juicy threetree.net in a new browser window

function openPOD(thisDay) {

	if (window.widget)
		widget.openURL('http://www.threetree.net/index.php?day=' + thisDay);

	showPOD = false; 		

	PODViewed(new Date());

	reloadFeed();
	
}

// Opens up to the download page on threetree.net

function openVersion() {

	if (window.widget)
		widget.openURL('http://www.threetree.net/widgets/gpeek/download.html');

	newVersion = false; 		
}

// Toggle between the three positions when the small number or the GPeek logo is clicked
// Just a little easier than always having to aim for those little arrows

function toggleState() {

	if (username=="") {
		showPrefs();
		return false;
	}

	if (!isHWidgetOpen) {
		toggleHOpen();
	} else if (!isVWidgetOpen) {
		toggleVOpen();
	} else {
		toggleHOpen();
	}
}

// If the widget is vertically extended - close it up & vice-versa

function toggleVOpen() {

	enableSummary = false;

	if (username=="") {
		showPrefs();
		return false;
	}	

	if (isVWidgetOpen) {
	
		if (document.getElementById('summary').style.height != "0px") {
			stretcher_summary.stretch(event, 0, NO_RESIZE_WIDGET, VERTICAL);
		}

		stretcher.stretch(event, 69, RESIZE_WIDGET, VERTICAL);
		
	} else {
	
		if (!isHWidgetOpen) {
			toggleHOpen();
			setTimeout('toggleVOpen()',800);
			return true;
		}
		stretcher.stretch(event, 39 * mail_count + 180, RESIZE_WIDGET, VERTICAL);
	}
}

// If the widget is horizontally extended - close it up & vice-versa

function toggleHOpen() {

	if (username=="") {
		showPrefs();
		return false;
	}
	
	if (isHWidgetOpen) {
		
		if (isVWidgetOpen) {
			toggleVOpen();
			setTimeout('toggleHOpen()',800);
			return true;
		}

		fadeLogo();
	
		if (mail_count > 9) {
			horizontal_stretcher.stretch(event, 134, RESIZE_WIDGET, HORIZONTAL);
		} else {
			horizontal_stretcher.stretch(event, 120, RESIZE_WIDGET, HORIZONTAL);
		}
		
	} else {
	
		horizontal_stretcher.stretch(event, 222, RESIZE_WIDGET, HORIZONTAL);
	}
}

// Fades the GPeek logo and the connection info when you go from mini to slick

function fadeLogo () {

		if (animation.timer != null) {
	    	clearInterval (animation.timer);
		    animation.timer  = null;
		}
	
		var starttime = (new Date).getTime() - 13;
		animation.duration = 700;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById('logo_name');
		animation.secondElement = document.getElementById('connected');
		animation.timer = setInterval("animate();", 13);
		animation.from = animation.now;
		if (isHWidgetOpen) {
			animation.to = 0;
			animation.from = 1;
		} else {
			animation.to = 1;
			animation.from = 0;
		}
		animate();
		
}

// Makes the currently moused over message look all pretty for the cameras
// Parameters:	id - Sequential unique identifier that is automatically added to each message

function messageMouseOver(event,id) {

	//if (!enableSummary) return false;

	document.getElementById('arrow'+id).style.backgroundImage = "url('Images/Arrow-Yellow.gif')";
	document.getElementById('message'+id).style.background = "#FFFFFF";
	document.getElementById('subject'+id).style.color = "#087100";
	document.getElementById('sender'+id).style.color = "#087100";	
	
	clearInterval(sumTimer);
	sumTimer = null;
	
	if (!isSummaryOpen) {
		stretcher_summary.stretch(event, 81, NO_RESIZE_WIDGET, VERTICAL);
	}
	
	if (id==99) {
		
		document.pod_thumb.src = thumb.src;
		
		document.getElementById('summary_date').innerHTML = "";
		document.getElementById('summary_text').innerHTML = "";
	
		document.getElementById('summary_pod').innerHTML = document.getElementById('sum'+id).innerHTML;
		
	
	} else {
	
		document.getElementById('summary_pod').innerHTML = "";
		
		document.getElementById('summary_date').innerHTML = document.getElementById('date'+id).innerHTML;
		document.getElementById('summary_text').innerHTML = document.getElementById('sum'+id).innerHTML;
	}
}

// Returns a message to it's dull former self

function messageMouseOut(event,id) {

	document.getElementById('arrow'+id).style.backgroundImage = "url('Images/Arrow-White.gif')";
	document.getElementById('message'+id).style.background = "none";
	document.getElementById('subject'+id).style.color = "#FFFFFF";
	document.getElementById('sender'+id).style.color = "#FFFFFF";	
	
	sumTimer = setTimeout('stretcher_summary.stretch(event, 0, NO_RESIZE_WIDGET, VERTICAL)',1);
	
}

// If the Enter key is pressed on the flip side it's performs the same action as click on Done

function handleEnter() {
    
    var keyCode = event.keyCode ? event.keyCode : event.which ? event.which : event.charCode;
        
    if (keyCode == 13) {
        hidePrefs();
    }
}


// Used to debug this beast of a JS script

function debug(thisMsg,append) {
	if (append) 
		document.getElementById('debug').innerHTML += thisMsg;
	else
		document.getElementById('debug').innerHTML = thisMsg;
}
